diff --git a/src/main/java/net/minecraft/server/net/command/commands/CommandWhoIs.java b/src/main/java/net/minecraft/server/net/command/commands/CommandWhoIs.java
index ba2f5f9c8..d8dcc8dbc 100644
--- a/src/main/java/net/minecraft/server/net/command/commands/CommandWhoIs.java
+++ b/src/main/java/net/minecraft/server/net/command/commands/CommandWhoIs.java
@@ -6,13 +6,14 @@ import com.mojang.brigadier.builder.LiteralArgumentBuilder;
 import com.mojang.brigadier.builder.RequiredArgumentBuilder;
 import com.mojang.brigadier.tree.CommandNode;
 import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.net.command.util.CommandHelper;
 import net.minecraft.core.net.command.CommandSource;
 import net.minecraft.core.net.command.arguments.ArgumentTypeEntity;
 import net.minecraft.core.net.command.helpers.EntitySelector;
 
-public class CommandWhoIs {
-    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+public class CommandWhoIs implements CommandManager.CommandRegistry {
+    public void register(CommandDispatcher<CommandSource> dispatcher) {
         CommandNode<CommandSource> command = dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("whois")
                 .then(RequiredArgumentBuilder.<CommandSource, EntitySelector>argument("target", ArgumentTypeEntity.player())
                         .executes(c -> {
diff --git a/src/main/java/net/minecraft/server/net/handler/PacketHandlerLogin.java b/src/main/java/net/minecraft/server/net/handler/PacketHandlerLogin.java
index 636d9d959..64b46d22b 100644
--- a/src/main/java/net/minecraft/server/net/handler/PacketHandlerLogin.java
+++ b/src/main/java/net/minecraft/server/net/handler/PacketHandlerLogin.java
@@ -201,7 +201,7 @@ public class PacketHandlerLogin extends PacketHandler
             packetHandler.sendPacket(new SetSpawnPositionPacket(chunkcoordinates.x, chunkcoordinates.y, chunkcoordinates.z));
             mcServer.playerList.setTime(player, worldserver);
             mcServer.playerList.sendPacketToAllPlayers(new ChatPacket(TextFormatting.YELLOW + player.getDisplayName() + TextFormatting.YELLOW + " joined the game."));
-            mcServer.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(player.username, player.nickname, player.uuid, player.score, player.chatColor, true, player.isOperator()));
+            mcServer.playerList.updatePlayerProfile(player.username, player.nickname, player.uuid, player.score, player.chatColor, true, player.isOperator());
 
             if (mcServer.joinMessage != null && !mcServer.joinMessage.isEmpty())
             {
diff --git a/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java b/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java
index f7dc7e0e7..75cc53024 100644
--- a/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java
+++ b/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java
@@ -21,6 +21,7 @@ import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.player.inventory.container.ContainerInventory;
 import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.world.World;
+import net.minecraft.server.net.PlayerList;
 import net.minecraft.server.net.command.ServerCommandSource;
 import net.minecraft.core.net.handler.PacketHandler;
 import net.minecraft.core.net.packet.*;
@@ -39,7 +40,7 @@ import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.chunk.ChunkCoordinates;
 import net.minecraft.server.MinecraftServer;
 import net.minecraft.server.entity.player.PlayerServer;
-import net.minecraft.server.util.helper.PlayerList;
+import net.minecraft.server.player.PlayerListBox;
 import net.minecraft.server.world.WorldServer;
 import org.slf4j.Logger;
 
@@ -83,14 +84,14 @@ public class PacketHandlerServer extends PacketHandler
         sendPacket(new DisconnectPacket(s));
         netManager.serverShutdown();
         mcServer.playerList.sendPacketToAllPlayers(new ChatPacket(playerEntity.getDisplayName() + TextFormatting.YELLOW + " was kicked from the game."));
-        mcServer.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(playerEntity.username, playerEntity.nickname, playerEntity.uuid, playerEntity.score, playerEntity.chatColor, false, playerEntity.isOperator()));
+        mcServer.playerList.updatePlayerProfile(playerEntity.username, playerEntity.nickname, playerEntity.uuid, playerEntity.score, playerEntity.chatColor, false, playerEntity.isOperator());
         mcServer.playerList.playerLoggedOut(playerEntity);
         connectionClosed = true;
         if (MinecraftServer.statsStatus)
         {
             RestHandler.post("https://api.betterthanadventure.net/stats?serverToken=" + MinecraftServer.statsToken + "&count=" + mcServer.playerList.playerEntities.size());
         }
-        PlayerList.updateList();
+        PlayerListBox.updateList();
     }
 
     @Override
@@ -366,6 +367,7 @@ public class PacketHandlerServer extends PacketHandler
         {
             sendPacket(new UpdatePlayerProfilePacket(playerServer.username, playerServer.nickname, playerServer.uuid, playerServer.score, playerServer.chatColor, true, playerServer.isOperator()));
         }
+        PlayerListBox.updateList();
     }
 
     @Override
@@ -433,14 +435,14 @@ public class PacketHandlerServer extends PacketHandler
     {
         LOGGER.info(playerEntity.username + " lost connection: " + message);
         mcServer.playerList.sendPacketToAllPlayers(new ChatPacket(playerEntity.getDisplayName() + TextFormatting.YELLOW + " left the game."));
-        mcServer.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(playerEntity.username, playerEntity.nickname, playerEntity.uuid, playerEntity.score, playerEntity.chatColor, false, playerEntity.isOperator()));
+        mcServer.playerList.updatePlayerProfile(playerEntity.username, playerEntity.nickname, playerEntity.uuid, playerEntity.score, playerEntity.chatColor, false, playerEntity.isOperator());
         mcServer.playerList.playerLoggedOut(playerEntity);
         connectionClosed = true;
         if (MinecraftServer.statsStatus)
         {
             RestHandler.post("https://api.betterthanadventure.net/stats?serverToken=" + MinecraftServer.statsToken + "&count=" + mcServer.playerList.playerEntities.size());
         }
-        PlayerList.updateList();
+        PlayerListBox.updateList();
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/server/player/PlayerListBox.java b/src/main/java/net/minecraft/server/player/PlayerListBox.java
index 1b6dbbd76..ace904e31 100644
--- a/src/main/java/net/minecraft/server/player/PlayerListBox.java
+++ b/src/main/java/net/minecraft/server/player/PlayerListBox.java
@@ -3,8 +3,10 @@ package net.minecraft.server.player;
 import java.util.Vector;
 import javax.swing.JList;
 
+import net.minecraft.core.net.packet.PlayerListPacket;
 import net.minecraft.server.MinecraftServer;
 import net.minecraft.core.net.IUpdatePlayerListBox;
+import net.minecraft.server.entity.player.PlayerServer;
 
 public class PlayerListBox extends JList<String>
     implements IUpdatePlayerListBox
@@ -33,4 +35,22 @@ public class PlayerListBox extends JList<String>
             setListData(vector);
         }
     }
+
+    public static void updateList() {
+        MinecraftServer server = MinecraftServer.getInstance();
+
+        int playerCount = server.playerList.playerEntities.size();
+
+        String[] players = new String[playerCount];
+        String[] scores = new String[playerCount];
+
+        for(int i=0; i < playerCount; i++) {
+            PlayerServer player = server.playerList.playerEntities.get(i);
+
+            players[i] = player.getDisplayName();
+            scores[i] = String.valueOf(player.getScore());
+        }
+
+        server.playerList.sendPacketToAllPlayers(new PlayerListPacket(playerCount, players, scores));
+    }
 }
